.NET Core MVC/TouristPlace/Models/ErrorViewModel.cs
using System;

namespace TouristPlace.Models {
    public class ErrorViewModel {
        public string RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

.NET Core MVC/TouristPlace/Models/Place.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace TouristPlace.Models {

    public class Place {
        public int Id { get; set; }

        [StringLength(60)]
        [Required]
        public string Name { get; set; }

        [Required]
        public string Address { get; set; }

        [Range(1, 5)]
        [Required]
        public decimal Rating { get; set; }

        public byte[] Image { get; set; }

        public string Picture { get; set; }
    }
}

.NET Core MVC/TouristPlace/Controllers/HomeController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using TouristPlace.Models;

namespace TouristPlace.Controllers {
    public class HomeController : Controller {
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger) {
            _logger = logger;
        }

        public IActionResult Index() {
            return View();
        }

        public IActionResult Privacy() {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error() {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

.NET Core MVC/TouristPlace/Controllers/PlacesController.cs
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using TouristPlace.Data;
using TouristPlace.Models;

namespace TouristPlace.Controllers {

    public class PlacesController : Controller {
        private bool sorted = false;
        private readonly MvcPlaceContext _context;
        private readonly IWebHostEnvironment _iwebhost;

        private void debug(string message) {
            System.Diagnostics.Debug.WriteLine("debug: " + message);
        }

        private List<string> supportedFileTypes = new List<string>()
        {
            ".jpeg",
            ".jpg",
            ".gif",
            ".png",
        };

        public PlacesController(MvcPlaceContext context, IWebHostEnvironment iwebhost) {
            _context = context;
            _iwebhost = iwebhost;
        }

        public void Sort() {
            if (sorted)
                sorted = false;
            else {
                sorted = true;
            }
        }

        // GET: Places
        public ActionResult Index(string searchString, string sortOrder) {
            ViewData["NameSortParm"] = String.IsNullOrEmpty(sortOrder) ? "name_desc" : "";
            ViewData["RatingSortParm"] = sortOrder == "Rating" ? "rating_desc" : "Rating";

            var places = from m in _context.Place
                         select m;

            switch (sortOrder) {
                case "name_desc":
                    places = places.OrderByDescending(s => s.Name);
                    break;

                case "Rating":
                    places = places.OrderBy(s => s.Rating);
                    break;

                case "rating_desc":
                    places = places.OrderByDescending(s => s.Rating);
                    break;

                default:
                    places = places.OrderBy(s => s.Name);
                    break;
            }

            if (!String.IsNullOrEmpty(searchString)) {
                places = places.Where(s => s.Name.Contains(searchString));
                ViewData["searchTerms"] = "Showing results for '" + searchString + "'";
            }
            else {
                ViewData["searchTerms"] = "";
            }
            return View(places);
        }

        public async Task<IActionResult> Details(int? id) {
            if (id == null) {
                return NotFound();
            }

            var place = await _context.Place
                .FirstOrDefaultAsync(m => m.Id == id);
            if (place == null) {
                return NotFound();
            }

            return View(place);
        }

        public IActionResult Create() {
            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create([Bind("Id,Name,Address,Rating")] Place place, IFormFile Picture) {
            if (Picture == null) {
                ViewData["imageMessage"] = "The Image field is required.";
                return View(place);
            }

            string imgExtension = Path.GetExtension(Picture.FileName);

            if (!supportedFileTypes.Contains(imgExtension)) {
                ViewData["imageMessage"] = "Unsupported file type.";
                return View(place);
            }

            string filename = Guid.NewGuid() + imgExtension;

            var savedImage = Path.Combine(_iwebhost.WebRootPath, "images", filename);
            var stream = new FileStream(savedImage, FileMode.Create);
            await Picture.CopyToAsync(stream);
            place.Picture = filename;

            if (ModelState.IsValid) {
                _context.Add(place);
                await _context.SaveChangesAsync();
                return RedirectToAction(nameof(Index));
            }
            return View(place);
        }

        public async Task<IActionResult> Edit(int? id) {
            if (id == null) {
                return NotFound();
            }

            var place = await _context.Place.FindAsync(id);
            if (place == null) {
                return NotFound();
            }
            return View(place);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(int id, [Bind("Id,Name,Address,Rating")] Place place, IFormFile Picture) {
            if (id != place.Id) {
                return NotFound();
            };
            var oldValue = await _context.Place.AsNoTracking().FirstOrDefaultAsync(a => a.Id == id);

            if (Picture == null) {
                place.Picture = oldValue.Picture;
            }
            else {
                string imgExtension = Path.GetExtension(Picture.FileName);

                if (!supportedFileTypes.Contains(imgExtension)) {
                    ViewData["imageMessage"] = "Unsupported file type.";
                    return View(place);
                }
                string filename = Guid.NewGuid() + imgExtension;
                var savedImage = Path.Combine(_iwebhost.WebRootPath, "images", filename);
                var stream = new FileStream(savedImage, FileMode.Create);
                await Picture.CopyToAsync(stream);
                place.Picture = filename;
            }

            if (ModelState.IsValid) {
                try {
                    _context.Update(place);
                    await _context.SaveChangesAsync();
                }
                catch (DbUpdateConcurrencyException) {
                    if (!PlaceExists(place.Id)) {
                        return NotFound();
                    }
                    else {
                        throw;
                    }
                }
                return RedirectToAction(nameof(Index));
            }
            return View(place);
        }

        public async Task<IActionResult> Delete(int? id) {
            if (id == null) {
                return NotFound();
            }

            var place = await _context.Place
                .FirstOrDefaultAsync(m => m.Id == id);
            if (place == null) {
                return NotFound();
            }

            return View(place);
        }

        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(int id) {
            var place = await _context.Place.FindAsync(id);
            _context.Place.Remove(place);
            await _context.SaveChangesAsync();
            return RedirectToAction(nameof(Index));
        }

        private bool PlaceExists(int id) {
            return _context.Place.Any(e => e.Id == id);
        }

        [HttpGet]
        public ActionResult Search() {
            return PartialView("_SearchFormPartial");
        }
    }
}

.NET Core MVC/TouristPlace/Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<div class="text-center">
    <h1 class="display-4"><a class="navbar-brand" asp-area="" asp-controller="Places" asp-action="Index">Welcome to Tourist App</a></h1>
</div>

.NET Core MVC/TouristPlace/Views/Places/Create.cshtml
@model TouristPlace.Models.Place

@{
    ViewData["Title"] = "Create";
}

<h1>Create</h1>

<h4>Place</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Create" method="post" enctype="multipart/form-data">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="Name" class="control-label"></label>
                <input asp-for="Name" class="form-control" />
                <span asp-validation-for="Name" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Address" class="control-label"></label>
                <input asp-for="Address" class="form-control" />
                <span asp-validation-for="Address" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Rating" class="control-label"></label>
                <input asp-for="Rating" type="number" value="1" min="1" max="5" class="form-control" />
                <span asp-validation-for="Rating" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Picture" class="control-label"></label>
                <input asp-for="Picture" class="form-control" type="file" />
                <span asp-validation-for="Picture" class="text-danger"></span>
                <span style="color:red">@ViewData["imageMessage"]</span>
            </div>
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

.NET Core MVC/TouristPlace/Views/Places/Delete.cshtml
@model TouristPlace.Models.Place

@{
    ViewData["Title"] = "Delete";
}

<h1>Delete</h1>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>Place</h4>
    <hr />
    <dl class="row">
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Name)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Name)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Address)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Address)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.Rating)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Rating)
        </dd>
        <dt class="col-sm-2">
            Picture
        </dt>
        <dd class="col-sm-10">
            <img src="~/images/@Model.Picture" alt="not found" height=100 width=100 style="padding: 5px" />
        </dd>
    </dl>

    <form asp-action="Delete">
        <input type="hidden" asp-for="Id" />
        <input type="submit" value="Delete" class="btn btn-danger" /> |
        <a asp-action="Index">Back to List</a>
    </form>
</div>

.NET Core MVC/TouristPlace/Views/Places/Details.cshtml
@model TouristPlace.Models.Place

@{
    ViewData["Title"] = "Details";
}

<h1>Details</h1>

<div>
    <h4>Place</h4>
    <hr />
    <dl class="row">
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Name)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Name)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Address)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Address)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Rating)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Rating)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Picture)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Picture)
        </dd>
    </dl>
</div>
<div>
    <a asp-action="Edit" asp-route-id="@Model.Id">Edit</a> |
    <a asp-action="Index">Back to List</a>
</div>

.NET Core MVC/TouristPlace/Views/Places/Edit.cshtml
@model TouristPlace.Models.Place

@{
    ViewData["Title"] = "Edit";
}

<h1>Edit</h1>

<h4>Place</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Edit" method="post" enctype="multipart/form-data">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <input type="hidden" asp-for="Id" />
            <div class="form-group">
                <label asp-for="Name" class="control-label"></label>
                <input asp-for="Name" class="form-control" />
                <span asp-validation-for="Name" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Address" class="control-label"></label>
                <input asp-for="Address" class="form-control" />
                <span asp-validation-for="Address" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Rating" class="control-label"></label>
                <input asp-for="Rating" class="form-control" />
                <span asp-validation-for="Rating" class="text-danger"></span>
            </div>

            <img src="~/images/@Model.Picture" alt="not found" height=100 width=100 style="padding: 5px" />
            <div class="form-group">

                <label asp-for="Picture" class="control-label"></label>
                <input asp-for="Picture" class="form-control" type="file" />
                <span asp-validation-for="Picture" class="text-danger"></span>
                <span style="color:red">@ViewData["imageMessage"]</span>
            </div>
            <div class="form-group">
                <input type="submit" value="Save" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

.NET Core MVC/TouristPlace/Views/Places/Index.cshtml
@model IEnumerable<TouristPlace.Models.Place>

@{
    ViewData["Title"] = "Index";
}

<h1>List of Tourist Places</h1>
<form asp-controller="Places" asp-action="Index">
    <p>
        Search by Name <input type="text" name="SearchString">
        <a asp-action="Index" style="padding-left: 10px">Reset</a>
        <input type="submit" value="Submit" style="display: none" />
    <p style="color:green">@ViewData["searchTerms"]</p>
    </p>
</form>
<p>
    <a asp-action="Create">Create New</a>
</p>

<table class="table">
    <thead>
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.Name)
                @*<a asp-action="Index" asp-route-sortOrder="@ViewData["NameSortParm"]">@Html.DisplayNameFor(model => model.Name)</a>*@
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Address)
            </th>
            <th>

                @*@Html.DisplayNameFor(model => model.Rating)*@
                <a asp-action="Index" asp-route-sortOrder="@ViewData["RatingSortParm"]">@Html.DisplayNameFor(model => model.Rating)↑↓</a>
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Picture)
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var item in Model) {
            <tr class="Search">
                <td>
                    @Html.DisplayFor(modelItem => item.Name)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Address)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Rating)
                </td>
                <td>

                    <img src="~/images/@item.Picture" alt="not found" height=100 width=100 />
                </td>
                <td>
                    <a asp-action="Edit" asp-route-id="@item.Id">Edit</a> |
                    @*<a asp-action="Details" asp-route-id="@item.Id">Details</a> |*@
                    <a asp-action="Delete" asp-route-id="@item.Id">Delete</a>
                </td>
            </tr>
        }
    </tbody>
</table>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
<script>
    console.log("started")
    $(document).ready(function () {
        function Contains(text1, text2) {
            if (text1.indexOf(text2) != -1) {
                return true;
            }
        }
        $("#Search").keyup(function () {
            console.log($("#Search").val())
            var searchText = $("#Search").val().toLowerCase();
            $(".Search").each(function () {
                if (!Contains($(this).text().toLowerCase(), searchText)) {
                    $(this).hide();
                }
                else {
                    $(this).show();
                }
            })
        })

    })
</script>

.NET Core MVC/TouristPlace/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - TouristPlace</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Places" asp-action="Index">Tourist App</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                @*<div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                        <ul class="navbar-nav flex-grow-1">
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                            </li>
                        </ul>
                    </div>*@
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2020 - Tourist App | Shadman Ishrak
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js">
    </script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>